// Import entire swing library/package.
import javax.swing.*;
// Import specific parts of swing library/package.
//import javax.swing.JFrame;
//import javax.swing.JLabel;
//import javax.swing.JButton;

// Import libraries for handling events.
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

// We are only using the GridLayout, but you can use other layouts too.
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.GridLayout;

import java.awt.Color;

public class Calculator extends JFrame{
	// We make these global so that we can access them in the ButtonListener class.
	// We could add accessor methods (get/set) if we wanted to.
	JTextField txtFirstNumber; 	//firstTextBox
	JTextField txtSecondNumber; //secondTextBox
	JLabel labelResult; 		//lblResult, resultLabel
	
	public static void main(String args[]){
		Calculator gui = new Calculator(2, 3); //make a new Calculator JFrame with grid size 2 x 3
		gui.setVisible(true); //make sure you are making your window visible
		gui.addWindowListener(new MyWindowListener()); //add Window event listener to handle closing program
	}
	
	public Calculator(int rows, int columns){
		super(); //Calculator extended JFrame, so we want to call super() to construct the window
		setSize(400, 150); //width and height in pixels
		this.setTitle("Simple Calculator");
		setLayout(new GridLayout(rows, columns)); //set JFrame layout to grid, rows = 2, cols = 3
		
		// PANEL 1: first number
		JPanel firstNumberPanel = new JPanel(new GridLayout(2, 0));
		firstNumberPanel.setBackground(Color.WHITE);
		
		// PANEL 1: contents (label and textbox)
		JLabel labelFirstNumber = new JLabel("First number:"); 	//make a label
		txtFirstNumber = new JTextField(10); 					//make a new text box
		firstNumberPanel.add(labelFirstNumber); 				//add the label to the panel
		firstNumberPanel.add(txtFirstNumber); 					//add text box to the panel
		
		// PANEL 2: second number
		JPanel secondNumberPanel = new JPanel(new GridLayout(2, 0));
		secondNumberPanel.setBackground(Color.WHITE);
		
		// PANEL 2: contents (label and textbox)
		JLabel labelSecondNumber = new JLabel("Second number:");	//make a label
		txtSecondNumber = new JTextField(10); 						//make a new text box
		secondNumberPanel.add(labelSecondNumber); 					//add the label to the panel
		secondNumberPanel.add(txtSecondNumber); 					//add text box to the panel
		
		// BUTTON: click to add
		JButton additionButton = new JButton("Add!");
		additionButton.addActionListener(new ButtonListener()); //add event handler
		
		// LABEL: results
		labelResult = new JLabel("");
		
		// Add all our elements into Calculator JFrame
		add(firstNumberPanel);
		add(secondNumberPanel);
		add(additionButton);
		add(labelResult);
	}
	
	/**
	 * Handler for Button event.
	 */
	public class ButtonListener implements ActionListener {
		public void actionPerformed(ActionEvent e){
			// Get the numbers from the textboxes, convert them into numbers (doubles)
			Double firstValue = Double.parseDouble(txtFirstNumber.getText());
			Double secondValue = Double.parseDouble(txtSecondNumber.getText());
			
			// Add the numbers, then display it to the user. Has to be converted back to String first.
			Double result = firstValue + secondValue;
			labelResult.setText(result.toString());
		}
	}
	
}
